<?php
if( !defined('ABSPATH') )
	exit();
if( !class_exists('WPO_pressticket_Chart') ){
	class WPO_pressticket_Chart {
		var $enable = true;
		var $width = 520;
		var $height = 300;
		function __construct(){
			add_action('admin_enqueue_scripts', array($this,'admin_enqueue_scripts'));
			add_action('admin_footer', array($this,'show_chart'));
		}
		function admin_enqueue_scripts(){
			if( $this->enable === true ){
				wp_enqueue_script('google-chart-jsapi', 'https://www.google.com/jsapi');
			}
		}
		function show_chart(){
			$script = NULL;
			$status_option = NULL;
			$js_row = NULL;
			$status = wpo_ticket_get_status_options();
			if( is_array( $status ) ){
				foreach ( $status as $key=>$value ){
					$status_option .= '[\''.$value.'\', '.wpo_ticket_count_ticket_status($user_id, $key).'],';
				}
				$js_row .= '['. $status_option . ']';
			}
			if( $this->enable === true ){
				$script = '
				    <script type="text/javascript">
				      google.load(\'visualization\', \'1.0\', {\'packages\':[\'corechart\']});
				      google.setOnLoadCallback(drawChart);
				      function drawChart() {
				        // Create the data table.
				        var data = new google.visualization.DataTable();
				        data.addColumn(\'string\', \'Topping\');
				        data.addColumn(\'number\', \'Slices\');
				        data.addRows('.$js_row.')
				        var options = {\'title\':\''.__('Status Summary','wpo').'\',
				                       \'width\':'.$this->width.',
				                       \'height\':'.$this->height.'};
				        var chart = new google.visualization.PieChart(document.getElementById(\'chart_ticket\'));
				        chart.draw(data, options);
				      }
				    </script>
				';
			}
			print $script;
		}
	}
	$WPO_pressticket_Chart = new WPO_pressticket_Chart();
}