<?php
if( !defined('ABSPATH') )
	exit();
if( !function_exists('WPO_pressticket_Dashboard') ){
	class WPO_pressticket_Dashboard {
		var $avatar_size = 32;
		var $show_items = 5;
		var $show_chart = true;
		function __construct(){
			add_action('wp_dashboard_setup', array($this,'wp_dashboard_setup'));
		}
		function wp_dashboard_setup(){
			$user_id = get_current_user_id();
			if( !user_can($user_id, wpo_ticket_cap_delete_ticket()) || !user_can($user_id, wpo_ticket_cap_update_ticket()) ){
				$title = __('Your tickets','wpo');
			}
			else{
				wp_add_dashboard_widget('pressticket-chart', __('Summary Chart','wpo'), array($this,'chart_called'));
				$title = __('New Tickets','wpo');
			}
			wp_add_dashboard_widget('pressticket-newtickets',$title, array($this,'ticketlist_call'));
		}
		function chart_called(){
			$html = null;
			if( $this->show_chart === true ){
				$html .= '<div id="chart_ticket"></div>';
			}
			print $html;
		}
		function ticketlist_call(){
			print $this->tickets_list(get_current_user_id());
		}
		function tickets_list($user_id){
			$html = NULL;
			$args = array(
				'post_type'	=>	'wp-ticket',
				'posts_per_page'	=>	$this->show,
				'orderby'          => 'post_date',
				'order'            => 'DESC',
				'post_status'      => 'publish',
				'meta_query' => array(
					array(
						'key' => 'wpo_ticket_status',
						'value' => 'open',
						'compare' => '=='
					)
				)			
			);
			if( !user_can($user_id, wpo_ticket_cap_delete_ticket()) || !user_can($user_id, wpo_ticket_cap_update_ticket()) ){
				$args['author'] = $user_id;
			}
			$tickets = get_posts($args);
			if( $tickets ){	
				$html .= '<table class="form-table press-ticket-permission">';
					$html .= '
						<thead>
							<tr>
								<th scope="col">'.__('#ID','wpo').'</th>
								<th scope="col">'.__('Author','wpo').'</th>
								<th scope="col">'.__('Issue','wpo').'</th>
								<th scope="col">'.__('Priority','wpo').'</th>
							</tr>
						</thead><tbody>
					';
					foreach ( $tickets as $ticket ){
						$html .= '<tr>
							<th scope="col">'.wpo_ticket_get_ticketID($ticket->ID).'</th>
							<th scope="col">'. get_avatar(wpo_ticket_get_author_id_post_id($ticket->ID), $this->avatar_size ) .'</th>
							<th scope="col">
								<div><a target="_blank" href="'.get_permalink( $ticket->ID ).'">'. $ticket->post_title .'</a></div>';
							if( wpo_ticket_count_reply($ticket->ID) > 1 ){
								$html .= '<i><a href="'.admin_url('edit.php?post_type=wp-ticket&page=new-reply&ticket='.$ticket->ID).'"><span class="label">'.wpo_ticket_count_reply($ticket->ID).' '.__('Responses','wpo').'</span></a><i>';	
							}
							else{
								$html .= '<i><a href="'.admin_url('edit.php?post_type=wp-ticket&page=new-reply&ticket='.$ticket->ID).'"><span class="label">'.wpo_ticket_count_reply($ticket->ID).' '.__('Response','wpo').'</span></a><i>';
							}						
						$html .= '
							</th>
							<th scope="col">'. wpo_ticket_hightlight_priority( wpo_ticket_get_ticket_priority($ticket->ID, true) ) .'</th>					
						</tr>';
					}
				$html .= '</tbody></table>';
				$html .= '<p><a href="'.admin_url('edit.php?post_type=wp-ticket').'"><strong>'.__('View all tickets','wpo').'</strong><a></p>';
			}
			else{
				$html .= __('No ticket','wpo');
			}
			return $html;
		}
	}
	$WPO_pressticket_Dashboard = new WPO_pressticket_Dashboard();
}