<?php
if( !defined('ABSPATH') )
	exit();
if(!function_exists('wpo_ticket_cap_view_ticket')){
	/**
	 * View and open ticket
	 */
	function wpo_ticket_cap_view_ticket() {
		return 'view_ticket';
	}
}
if(!function_exists('wpo_ticket_cap_update_ticket')){
	/**
	 * Update ticket
	 */
	function wpo_ticket_cap_update_ticket() {
		return 'update_ticket';
	}
}
if(!function_exists('wpo_ticket_cap_delete_ticket')){
	/**
	 * Delete ticket
	 */
	function wpo_ticket_cap_delete_ticket() {
		return 'delete_ticket';
	}
}

if(!function_exists('wpo_ticket_cap_manage_ticket')){
	function wpo_ticket_cap_manage_ticket() {
		return 'manage_ticket';
	}
}
if(!function_exists('wpo_ticket_cap_allow_admin_default')){
	function wpo_ticket_cap_allow_admin_default(){
		$users = get_users(array(
			'role'	=>	'administrator'
		));
		if($users){
			foreach ($users as $user){
				$cap = new WP_User( $user->ID );
				$cap->add_cap( wpo_ticket_cap_manage_ticket()  );
				$cap->add_cap( wpo_ticket_cap_view_ticket()  );
				$cap->add_cap( wpo_ticket_cap_update_ticket()  );
				$cap->add_cap( wpo_ticket_cap_delete_ticket()  );
			}
		}
	}
	add_action('init', 'wpo_ticket_cap_allow_admin_default');
}
if(!function_exists('wpo_ticket_check_delete_ticket')){
	function wpo_ticket_check_delete_ticket($post_id){
		global $post_type;
		if(is_admin()){
			if( $post_type=='wp-ticket' ){
				if( !current_user_can( wpo_ticket_cap_delete_ticket() ) ){
					wp_die( __('You do not have the right permission to use this feature!','wpo') );
				}
			}
		}
	}
	add_action('before_delete_post', 'wpo_ticket_check_delete_ticket');
	add_action('wp_trash_post', 'wpo_ticket_check_delete_ticket');
}
if(!function_exists('wpo_ticket_can_view_ticket')){
	function wpo_ticket_can_view_ticket(){
		global $post;
		global $posttype;
		if(get_post_type()=='wp-ticket' && !is_admin()){
			if( wpo_ticket_option_helpdesk_status()=='yes' ){
				//wp_die( wpo_ticket_option_helpdesk_status_messages() ,'Notice');
			}
			if( !get_current_user_id() ){
				wp_redirect(get_bloginfo('url') . '/wp-login.php');exit();
			}
			else{
				### admin
				if( user_can(get_current_user_id(), 'add_users') ){
					return;
				}
				if( current_user_can( wpo_ticket_cap_update_ticket() ) || current_user_can( wpo_ticket_cap_delete_ticket() ) ){
					return;
				}
				if( get_current_user_id() == wpo_ticket_get_author_id_post_id($post->ID) ){
					return;
				}
				else wp_redirect( wpo_ticket_get_url_myticket() );exit();
			}
		}
	}
	add_action('wp', 'wpo_ticket_can_view_ticket');
}
if(!function_exists('wpo_ticket_add_cap_upload_files_new_users')){
	function wpo_ticket_add_cap_upload_files_new_users($user_id) {
		if ( wpo_ticket_option_allow_users_upload_files()=='yes' ){
			$user = new WP_User( $user_id );
			$user->add_cap( 'upload_files' );			
		}
		return;
	}
	add_action('user_register', 'wpo_ticket_add_cap_upload_files_new_users');
}
if(!function_exists('wpo_ticket_add_cap_open_ticket_new_users')){
	function wpo_ticket_add_cap_open_ticket_new_users($user_id) {
		if( wpo_ticket_option_allow_users_open_ticket()=='yes' ){
			$user = new WP_User( $user_id );
			$user->add_cap( wpo_ticket_cap_view_ticket() );				
		}
		return;
	}
	add_action('user_register', 'wpo_ticket_add_cap_open_ticket_new_users');
}


